The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to keep the enemy in the dark. — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don‘t know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
#include
#include
#include<string.h>
#include
#include
#define N 11000
using namespace std;
int prime(int n)
{
int i,k;
k=(int)sqrt(n);
for(i=2;i<=k;i++)
if(n%i==0)
return 0;
return 1;
}
struct node
{
int x,step;
friend bool operator<(node a,node b)
{
return a.step>b.step;
}
};
int dfs(int m,int n)
{
int a[4]={1,10,100,1000};
int vis[N];
priority_queueQ;
node q,p;
memset(vis,0,sizeof(vis));
vis[m]=1;
q.x=m;
q.step=0;
Q.push(q);
while(!Q.empty())
{
q=Q.top();
Q.pop();
if(q.x==n)
return q.step;
for(int i=0;i<4;i++)//控制改变的哪一位
{
for(int j=0;j<10;j++)//把相对应的那一位变成j;
{
int L=q.x/(a[i]*10);
int R=q.x%(a[i]);
p.x=L*(a[i]*10)+j*a[i]+R;//重新组成的数;
if(p.x>=1000&&vis[p.x]==0&&prime(p.x)==1)
{
vis[p.x]=1;
p.step=q.step+1;
Q.push(p);
}
}
}
}
return -1;
}
int main()
{
int T,m,n,ans;
scanf("%d",&T);
while(T--)
{
scanf("%d%d",&m,&n);
ans=dfs(m,n);
if(ans==-1)
printf("Impossible\n");
else
printf("%d\n",ans);
}
return 0;
}